/* jshint esnext:true */


//filters out everything but valid number values
function textToNum(text){
  var num;
  if(typeof text === 'number'){
    num = text;
  }else if(typeof text === 'string'){
    num = text.match(/[-]?[\d.]+/g);
    if(num !== null){
      num = Number(num.join(''));
    }else{
      num = 0;
    }
  }else{
    num = 0;
  }
  return num;
}


//formats string as a curency
function currencyFormat(text){
  var amount = textToNum(text);
  var fixedAmount;
  if(isNaN(amount)){
    fixedAmount = text;
  }else{
    fixedAmount = new Intl.NumberFormat('en', {style: 'currency', currency: 'USD'}).format(amount);
  }
  return fixedAmount;
}


//sums an array of numbers
function sum(array){
  if(array !== null){
    return array.reduce((a, b) => a + b, 0);
  }else{
    return null;
  }
}


//formats a string as a phone number
function phoneFormat(string) {
  var nums = (string || '').replace(/\D/g, '');
  nums = nums.toString();
  nums = nums[0] === '1' ? nums.slice(1) : nums;
  var ext = nums.length > 10 ? ' x' + nums.slice(10) : '';
  return '(' + nums.slice(0, 3) + ') ' + nums.slice(3, 6) + '-' + nums.slice(6, 10) + ext;
}


//used to view raw html without it rendering
function escape_HTML(html_str) {
    'use strict';

    return html_str.replace(/[&<>"\n]/g, function (tag) {
		var chars_to_replace = {
            '&': '&amp;',
            '<': '&lt;',
            '>': '&gt;',
            '"': '&quot;',
            "'": '&#x27;',
            '/': '&#x2F;',
           '\n': '&#13;'
            };

		return chars_to_replace[tag] || tag;
	});
}


//removes << and >> from email templates when previewing
function removeCarrots(string){
    return string.replace(/<{2}|>{2}/g, "");
}



